/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc     VDK_MODULE
//
// @module  Example VDK | This module provides the main module for an Example
//          VDK. 
//
//          Typically VDKs will be loaded by the Cyrano Daemon applciation
//          and utilise the Factory within that application.
//
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// OpenSTA includes.
#include <Daemon/CyrVdk.h>
#include "Example_i.h"

///////////////////////////////////////////////////////////////////////////////
// Global variables
ExampleImpl* ExampleS = NULL;

///////////////////////////////////////////////////////////////////////////////
// @func   This function initialises the Example VDK.
//
// @rdesc   A standard OpenSTA error code.
//
VDK_EXP CyrVdkInitialise (const char* factory, CORBAServer* pServer)
{
    ExampleS = new ExampleImpl(pServer);
    return CYR_SUCCESS;
}

///////////////////////////////////////////////////////////////////////////////
// @func    This function stops the Example VDK
//
// @rdesc   A standard OpenSTA error code.
//
VDK_EXP CyrVdkUninitialise()
{
    delete ExampleS;
    return CYR_SUCCESS;
}