/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

///////////////////////////////////////////////////////////////////////////////
// @doc CyrFFApi
///////////////////////////////////////////////////////////////////////////////

#ifndef _CECFFNodeFile_h
#define _CECFFNodeFile_h

///////////////////////////////////////////////////////////////////////////////
// Cyrano includes
#include <CyrffApi/CECFFFile.h>

///////////////////////////////////////////////////////////////////////////////
// @class   CECFFNodeFile | This class represents an node definition file..
// @base    public | CECFFFile
class CYR_EXPORT CECFFNodeFile : public CECFFFile
{
    // @access Public Members
public:
    // @cmember Constructor used to retrieve a File
    CECFFNodeFile( CECFFFolder* parent, const char* name );
    // @cmember Constructor used to create a new File
    CECFFNodeFile( CECFFFolder* parent, const char* name, const char* desc );

    // @cmember Set the node definition fields
    void    SetNode     (string& PhysicalNode
                         ,string& Username
                         ,string& Password);

    // @cmember Recover the node definition
    void    GetNode     (string& PhysicalNode
                         ,string& Username
                         ,string& Password);

    // @access Protected Members
protected:
};

#endif
