/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#include "Diagnostics.h"
#include <omniORB2/proxyCall.h>

static const char* _0RL_library_version = omniORB_2_7;


const char * Diagnostics::CLASS_NAME  = "Diagnostics";
// Proxy call descriptor class. Mangled signature:
//  _clong_i_cstring_i_cstring_i_cstring_i_cstring_i_clong
class _0RL_pc_bec4d6e9428400b9_00000000
            : public OmniProxyCallDesc
{
public:
inline _0RL_pc_bec4d6e9428400b9_00000000(const char* _op, size_t _op_len, const char* _a_Executable, const char* _a_User, const char* _a_Node, const char* _a__class, CORBA::Long _a_Level) :
    OmniProxyCallDesc(_op, _op_len),
    arg_Executable(_a_Executable),
    arg_User(_a_User),
    arg_Node(_a_Node),
    arg__class(_a__class),
    arg_Level(_a_Level)
    {}


    virtual CORBA::ULong alignedSize(CORBA::ULong size_in);
    virtual void marshalArguments(GIOP_C&);
    virtual void unmarshalReturnedValues(GIOP_C&);
    inline CORBA::Long result()
    {
        return pd_result;
    }

private:
    const char* arg_Executable;
    const char* arg_User;
    const char* arg_Node;
    const char* arg__class;
    CORBA::Long arg_Level;
    CORBA::Long pd_result;
};

CORBA::ULong _0RL_pc_bec4d6e9428400b9_00000000::alignedSize(CORBA::ULong msgsize)
{
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_Executable)? strlen((const char*) arg_Executable) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_User)? strlen((const char*) arg_User) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_Node)? strlen((const char*) arg_Node) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg__class)? strlen((const char*) arg__class) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4;
    return msgsize;
}

void _0RL_pc_bec4d6e9428400b9_00000000::marshalArguments(GIOP_C& giop_client)
{
    {
        CORBA::ULong _len = (((const char*) arg_Executable)? strlen((const char*) arg_Executable) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_Executable),_len);
        else
        {
            if ((const char*) arg_Executable == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    {
        CORBA::ULong _len = (((const char*) arg_User)? strlen((const char*) arg_User) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_User),_len);
        else
        {
            if ((const char*) arg_User == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    {
        CORBA::ULong _len = (((const char*) arg_Node)? strlen((const char*) arg_Node) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_Node),_len);
        else
        {
            if ((const char*) arg_Node == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    {
        CORBA::ULong _len = (((const char*) arg__class)? strlen((const char*) arg__class) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg__class),_len);
        else
        {
            if ((const char*) arg__class == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    arg_Level >>= giop_client;
}

void _0RL_pc_bec4d6e9428400b9_00000000::unmarshalReturnedValues(GIOP_C& giop_client)
{
    pd_result <<= giop_client;
}

CORBA::Long  _proxy_Diagnostics::AddClass(const char*  Executable, const char*  User, const char*  Node, const char*  _class, CORBA::Long  Level)
{
    _0RL_pc_bec4d6e9428400b9_00000000 _call_desc("AddClass", 9, Executable, User, Node, _class, Level);

    OmniProxyCallWrapper::invoke(this, _call_desc);
    return _call_desc.result();
}



// Proxy call descriptor class. Mangled signature:
//  _clong_i_cstring_i_cstring_i_cstring_i_cstring
class _0RL_pc_bec4d6e9428400b9_10000000
            : public OmniProxyCallDesc
{
public:
inline _0RL_pc_bec4d6e9428400b9_10000000(const char* _op, size_t _op_len, const char* _a_Executable, const char* _a_User, const char* _a_Node, const char* _a__class) :
    OmniProxyCallDesc(_op, _op_len),
    arg_Executable(_a_Executable),
    arg_User(_a_User),
    arg_Node(_a_Node),
    arg__class(_a__class)
    {}


    virtual CORBA::ULong alignedSize(CORBA::ULong size_in);
    virtual void marshalArguments(GIOP_C&);
    virtual void unmarshalReturnedValues(GIOP_C&);
    inline CORBA::Long result()
    {
        return pd_result;
    }

private:
    const char* arg_Executable;
    const char* arg_User;
    const char* arg_Node;
    const char* arg__class;
    CORBA::Long pd_result;
};

CORBA::ULong _0RL_pc_bec4d6e9428400b9_10000000::alignedSize(CORBA::ULong msgsize)
{
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_Executable)? strlen((const char*) arg_Executable) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_User)? strlen((const char*) arg_User) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_Node)? strlen((const char*) arg_Node) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg__class)? strlen((const char*) arg__class) + 1 : 1);
    return msgsize;
}

void _0RL_pc_bec4d6e9428400b9_10000000::marshalArguments(GIOP_C& giop_client)
{
    {
        CORBA::ULong _len = (((const char*) arg_Executable)? strlen((const char*) arg_Executable) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_Executable),_len);
        else
        {
            if ((const char*) arg_Executable == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    {
        CORBA::ULong _len = (((const char*) arg_User)? strlen((const char*) arg_User) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_User),_len);
        else
        {
            if ((const char*) arg_User == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    {
        CORBA::ULong _len = (((const char*) arg_Node)? strlen((const char*) arg_Node) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_Node),_len);
        else
        {
            if ((const char*) arg_Node == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    {
        CORBA::ULong _len = (((const char*) arg__class)? strlen((const char*) arg__class) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg__class),_len);
        else
        {
            if ((const char*) arg__class == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
}

void _0RL_pc_bec4d6e9428400b9_10000000::unmarshalReturnedValues(GIOP_C& giop_client)
{
    pd_result <<= giop_client;
}

CORBA::Long  _proxy_Diagnostics::DeleteClass(const char*  Executable, const char*  User, const char*  Node, const char*  _class)
{
    _0RL_pc_bec4d6e9428400b9_10000000 _call_desc("DeleteClass", 12, Executable, User, Node, _class);

    OmniProxyCallWrapper::invoke(this, _call_desc);
    return _call_desc.result();
}



// Proxy call descriptor class. Mangled signature:
//  _clong_i_cstring_i_cstring_i_cstring
class _0RL_pc_bec4d6e9428400b9_20000000
            : public OmniProxyCallDesc
{
public:
inline _0RL_pc_bec4d6e9428400b9_20000000(const char* _op, size_t _op_len, const char* _a_Executable, const char* _a_User, const char* _a_Node) :
    OmniProxyCallDesc(_op, _op_len),
    arg_Executable(_a_Executable),
    arg_User(_a_User),
    arg_Node(_a_Node)
    {}


    virtual CORBA::ULong alignedSize(CORBA::ULong size_in);
    virtual void marshalArguments(GIOP_C&);
    virtual void unmarshalReturnedValues(GIOP_C&);
    inline CORBA::Long result()
    {
        return pd_result;
    }

private:
    const char* arg_Executable;
    const char* arg_User;
    const char* arg_Node;
    CORBA::Long pd_result;
};

CORBA::ULong _0RL_pc_bec4d6e9428400b9_20000000::alignedSize(CORBA::ULong msgsize)
{
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_Executable)? strlen((const char*) arg_Executable) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_User)? strlen((const char*) arg_User) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_Node)? strlen((const char*) arg_Node) + 1 : 1);
    return msgsize;
}

void _0RL_pc_bec4d6e9428400b9_20000000::marshalArguments(GIOP_C& giop_client)
{
    {
        CORBA::ULong _len = (((const char*) arg_Executable)? strlen((const char*) arg_Executable) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_Executable),_len);
        else
        {
            if ((const char*) arg_Executable == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    {
        CORBA::ULong _len = (((const char*) arg_User)? strlen((const char*) arg_User) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_User),_len);
        else
        {
            if ((const char*) arg_User == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    {
        CORBA::ULong _len = (((const char*) arg_Node)? strlen((const char*) arg_Node) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_Node),_len);
        else
        {
            if ((const char*) arg_Node == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
}

void _0RL_pc_bec4d6e9428400b9_20000000::unmarshalReturnedValues(GIOP_C& giop_client)
{
    pd_result <<= giop_client;
}

CORBA::Long  _proxy_Diagnostics::DeleteAllClasses(const char*  Executable, const char*  User, const char*  Node)
{
    _0RL_pc_bec4d6e9428400b9_20000000 _call_desc("DeleteAllClasses", 17, Executable, User, Node);

    OmniProxyCallWrapper::invoke(this, _call_desc);
    return _call_desc.result();
}



CORBA::Long  _proxy_Diagnostics::IsTraced(const char*  Executable, const char*  User, const char*  Node)
{
    _0RL_pc_bec4d6e9428400b9_20000000 _call_desc("IsTraced", 9, Executable, User, Node);

    OmniProxyCallWrapper::invoke(this, _call_desc);
    return _call_desc.result();
}



// Proxy call descriptor class. Mangled signature:
//  _clong_i_cstring_i_cstring_i_cstring_o_cstring_i_cunsigned_plong_o_cstring_i_cunsigned_plong
class _0RL_pc_bec4d6e9428400b9_30000000
            : public OmniProxyCallDesc
{
public:
inline _0RL_pc_bec4d6e9428400b9_30000000(const char* _op, size_t _op_len, const char* _a_Executable, const char* _a_User, const char* _a_Node, char*& _a_Buff, CORBA::ULong _a_BufLen, char*& _a_LevelBuf, CORBA::ULong _a_LevelBufLen) :
    OmniProxyCallDesc(_op, _op_len),
    arg_Executable(_a_Executable),
    arg_User(_a_User),
    arg_Node(_a_Node),
    arg_Buff(_a_Buff),
    arg_BufLen(_a_BufLen),
    arg_LevelBuf(_a_LevelBuf),
    arg_LevelBufLen(_a_LevelBufLen)
    {}


    virtual CORBA::ULong alignedSize(CORBA::ULong size_in);
    virtual void marshalArguments(GIOP_C&);
    virtual void unmarshalReturnedValues(GIOP_C&);
    inline CORBA::Long result()
    {
        return pd_result;
    }

private:
    const char* arg_Executable;
    const char* arg_User;
    const char* arg_Node;
    char*& arg_Buff;
    CORBA::ULong arg_BufLen;
    char*& arg_LevelBuf;
    CORBA::ULong arg_LevelBufLen;
    CORBA::Long pd_result;
};

CORBA::ULong _0RL_pc_bec4d6e9428400b9_30000000::alignedSize(CORBA::ULong msgsize)
{
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_Executable)? strlen((const char*) arg_Executable) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_User)? strlen((const char*) arg_User) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4 + (((const char*) arg_Node)? strlen((const char*) arg_Node) + 1 : 1);
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4;
    msgsize = omni::align_to(msgsize,omni::ALIGN_4);
    msgsize += 4;
    return msgsize;
}

void _0RL_pc_bec4d6e9428400b9_30000000::marshalArguments(GIOP_C& giop_client)
{
    {
        CORBA::ULong _len = (((const char*) arg_Executable)? strlen((const char*) arg_Executable) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_Executable),_len);
        else
        {
            if ((const char*) arg_Executable == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    {
        CORBA::ULong _len = (((const char*) arg_User)? strlen((const char*) arg_User) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_User),_len);
        else
        {
            if ((const char*) arg_User == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    {
        CORBA::ULong _len = (((const char*) arg_Node)? strlen((const char*) arg_Node) + 1 : 1);
        _len >>= giop_client;
        if (_len > 1)
            giop_client.put_char_array((const CORBA::Char *)((const char*) arg_Node),_len);
        else
        {
            if ((const char*) arg_Node == 0 && omniORB::traceLevel > 1)
                _CORBA_null_string_ptr(0);
            CORBA::Char('\0') >>= giop_client;
        }
    }
    arg_BufLen >>= giop_client;
    arg_LevelBufLen >>= giop_client;
}

void _0RL_pc_bec4d6e9428400b9_30000000::unmarshalReturnedValues(GIOP_C& giop_client)
{
    char* _arg_Buff = 0;
    char* _arg_LevelBuf = 0;
    pd_result <<= giop_client;
    {
        CORBA::String_member _0RL_str_tmp;
        _0RL_str_tmp <<= giop_client;
        _arg_Buff = _0RL_str_tmp._ptr;
        _0RL_str_tmp._ptr = 0;
    }
    {
        CORBA::String_member _0RL_str_tmp;
        _0RL_str_tmp <<= giop_client;
        _arg_LevelBuf = _0RL_str_tmp._ptr;
        _0RL_str_tmp._ptr = 0;
    }
    arg_Buff = _arg_Buff;
    arg_LevelBuf = _arg_LevelBuf;
}

CORBA::Long  _proxy_Diagnostics::_0RL__GetClasses(const char*  Executable, const char*  User, const char*  Node, char* & Buff, CORBA::ULong  BufLen, char* & LevelBuf, CORBA::ULong  LevelBufLen)
{
    _0RL_pc_bec4d6e9428400b9_30000000 _call_desc("GetClasses", 11, Executable, User, Node, Buff, BufLen, LevelBuf, LevelBufLen);

    OmniProxyCallWrapper::invoke(this, _call_desc);
    return _call_desc.result();
}



CORBA::Boolean
_sk_Diagnostics::dispatch(GIOP_S &_0RL_s,const char *_0RL_op,CORBA::Boolean _0RL_response_expected)
{
    if (strcmp(_0RL_op,"AddClass") == 0)
    {
        CORBA::String_var Executable;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            Executable = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var User;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            User = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var Node;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            Node = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var _class;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            _class = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::Long Level;
        Level <<= _0RL_s;
        _0RL_s.RequestReceived();
        CORBA::Long _0RL_result;
        _0RL_result = AddClass(Executable, User, Node, _class, Level);
        size_t _0RL_msgsize = (size_t) GIOP_S::ReplyHeaderSize();
        _0RL_msgsize = omni::align_to(_0RL_msgsize,omni::ALIGN_4);
        _0RL_msgsize += 4;
        _0RL_s.InitialiseReply(GIOP::NO_EXCEPTION,(CORBA::ULong)_0RL_msgsize);
        _0RL_result >>= _0RL_s;
        _0RL_s.ReplyCompleted();
        return 1;
    }
    else if (strcmp(_0RL_op,"DeleteClass") == 0)
    {
        CORBA::String_var Executable;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            Executable = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var User;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            User = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var Node;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            Node = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var _class;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            _class = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        _0RL_s.RequestReceived();
        CORBA::Long _0RL_result;
        _0RL_result = DeleteClass(Executable, User, Node, _class);
        size_t _0RL_msgsize = (size_t) GIOP_S::ReplyHeaderSize();
        _0RL_msgsize = omni::align_to(_0RL_msgsize,omni::ALIGN_4);
        _0RL_msgsize += 4;
        _0RL_s.InitialiseReply(GIOP::NO_EXCEPTION,(CORBA::ULong)_0RL_msgsize);
        _0RL_result >>= _0RL_s;
        _0RL_s.ReplyCompleted();
        return 1;
    }
    else if (strcmp(_0RL_op,"DeleteAllClasses") == 0)
    {
        CORBA::String_var Executable;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            Executable = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var User;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            User = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var Node;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            Node = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        _0RL_s.RequestReceived();
        CORBA::Long _0RL_result;
        _0RL_result = DeleteAllClasses(Executable, User, Node);
        size_t _0RL_msgsize = (size_t) GIOP_S::ReplyHeaderSize();
        _0RL_msgsize = omni::align_to(_0RL_msgsize,omni::ALIGN_4);
        _0RL_msgsize += 4;
        _0RL_s.InitialiseReply(GIOP::NO_EXCEPTION,(CORBA::ULong)_0RL_msgsize);
        _0RL_result >>= _0RL_s;
        _0RL_s.ReplyCompleted();
        return 1;
    }
    else if (strcmp(_0RL_op,"IsTraced") == 0)
    {
        CORBA::String_var Executable;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            Executable = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var User;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            User = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var Node;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            Node = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        _0RL_s.RequestReceived();
        CORBA::Long _0RL_result;
        _0RL_result = IsTraced(Executable, User, Node);
        size_t _0RL_msgsize = (size_t) GIOP_S::ReplyHeaderSize();
        _0RL_msgsize = omni::align_to(_0RL_msgsize,omni::ALIGN_4);
        _0RL_msgsize += 4;
        _0RL_s.InitialiseReply(GIOP::NO_EXCEPTION,(CORBA::ULong)_0RL_msgsize);
        _0RL_result >>= _0RL_s;
        _0RL_s.ReplyCompleted();
        return 1;
    }
    else if (strcmp(_0RL_op,"GetClasses") == 0)
    {
        CORBA::String_var Executable;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            Executable = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var User;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            User = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var Node;
        {
            CORBA::String_member _0RL_str_tmp;
            _0RL_str_tmp <<= _0RL_s;
            Node = _0RL_str_tmp._ptr;
            _0RL_str_tmp._ptr = 0;
        }
        CORBA::String_var Buff;
        CORBA::ULong BufLen;
        BufLen <<= _0RL_s;
        CORBA::String_var LevelBuf;
        CORBA::ULong LevelBufLen;
        LevelBufLen <<= _0RL_s;
        _0RL_s.RequestReceived();
        CORBA::Long _0RL_result;
        _0RL_result = Diagnostics::GetClasses(Executable, User, Node, Buff, BufLen, LevelBuf, LevelBufLen);
        size_t _0RL_msgsize = (size_t) GIOP_S::ReplyHeaderSize();
        _0RL_msgsize = omni::align_to(_0RL_msgsize,omni::ALIGN_4);
        _0RL_msgsize += 4;
        _0RL_msgsize = omni::align_to(_0RL_msgsize,omni::ALIGN_4);
        _0RL_msgsize += 4 + (((const char*) Buff)? strlen((const char*) Buff) + 1 : 1);
        _0RL_msgsize = omni::align_to(_0RL_msgsize,omni::ALIGN_4);
        _0RL_msgsize += 4 + (((const char*) LevelBuf)? strlen((const char*) LevelBuf) + 1 : 1);
        _0RL_s.InitialiseReply(GIOP::NO_EXCEPTION,(CORBA::ULong)_0RL_msgsize);
        _0RL_result >>= _0RL_s;
        {
            CORBA::ULong _len = (((const char*) Buff)? strlen((const char*) Buff) + 1 : 1);
            _len >>= _0RL_s;
            if (_len > 1)
                _0RL_s.put_char_array((const CORBA::Char *)((const char*) Buff),_len);
            else
            {
                if ((const char*) Buff == 0 && omniORB::traceLevel > 1)
                    _CORBA_null_string_ptr(0);
                CORBA::Char('\0') >>= _0RL_s;
            }
        }
        {
            CORBA::ULong _len = (((const char*) LevelBuf)? strlen((const char*) LevelBuf) + 1 : 1);
            _len >>= _0RL_s;
            if (_len > 1)
                _0RL_s.put_char_array((const CORBA::Char *)((const char*) LevelBuf),_len);
            else
            {
                if ((const char*) LevelBuf == 0 && omniORB::traceLevel > 1)
                    _CORBA_null_string_ptr(0);
                CORBA::Char('\0') >>= _0RL_s;
            }
        }
        _0RL_s.ReplyCompleted();
        return 1;
    }
    else
    {
        return 0;
    }
}

_sk_Diagnostics::_sk_Diagnostics (const omniORB::objectKey& k)
{
    omniRopeAndKey l(0,(CORBA::Octet*)&k,(CORBA::ULong)sizeof(k));
    setRopeAndKey(l,0);
}

omniORB::objectKey
_sk_Diagnostics::_key()
{
    omniRopeAndKey l;
    getRopeAndKey(l);
    return (*((omniORB::objectKey*)l.key()));
}

Diagnostics_ptr
Diagnostics::_duplicate(Diagnostics_ptr obj)
{
    if (CORBA::is_nil(obj))
        return Diagnostics::_nil();
    CORBA::Object::_duplicate(obj);
    return obj;
}

Diagnostics_ptr
Diagnostics::_narrow(CORBA::Object_ptr obj)
{
    if (CORBA::is_nil(obj))
        return Diagnostics::_nil();
    Diagnostics_ptr e = (Diagnostics_ptr) (obj->PR_getobj()->_realNarrow(Diagnostics_IntfRepoID));
    if (e)
        return e;
    else
        return Diagnostics::_nil();
}

void *
Diagnostics::_widenFromTheMostDerivedIntf(const char *repoId,CORBA::Boolean is_cxx_type_id)
{
    if (is_cxx_type_id) return 0;
    if (!repoId)
        return (void *)((CORBA::Object_ptr)this);
    if (strcmp(Diagnostics_IntfRepoID,repoId) == 0)
        return (void *)this;
    else
    {
        return 0;
    }
}

CORBA::Boolean
Diagnostics::_0RL_is_a(const char *base_repoId)
{
    if (strcmp(base_repoId,(const char *)Diagnostics_IntfRepoID)==0)
        return 1;
    else
        return 0;
}

Diagnostics_ptr
Diagnostics_Helper::_nil()
{
    return Diagnostics::_nil();
}

CORBA::Boolean
Diagnostics_Helper::is_nil(Diagnostics_ptr p)
{
    return CORBA::is_nil(p);
}

void
Diagnostics_Helper::release(Diagnostics_ptr p)
{
    CORBA::release(p);
}

void
Diagnostics_Helper::duplicate(Diagnostics_ptr p)
{
    CORBA::Object::_duplicate(p);
}

size_t
Diagnostics_Helper::NP_alignedSize(Diagnostics_ptr obj,size_t initialoffset)
{
    return Diagnostics::NP_alignedSize(obj,initialoffset);
}

void
Diagnostics_Helper::marshalObjRef(Diagnostics_ptr obj,NetBufferedStream &s)
{
    Diagnostics::marshalObjRef(obj,s);
}

Diagnostics_ptr Diagnostics_Helper::unmarshalObjRef(NetBufferedStream &s)
{
    return Diagnostics::unmarshalObjRef(s);
}

void
Diagnostics_Helper::marshalObjRef(Diagnostics_ptr obj,MemBufferedStream &s)
{
    Diagnostics::marshalObjRef(obj,s);
}

Diagnostics_ptr Diagnostics_Helper::unmarshalObjRef(MemBufferedStream &s)
{
    return Diagnostics::unmarshalObjRef(s);
}

const char *
Diagnostics_proxyObjectFactory::irRepoId() const
{
    return (const char *)Diagnostics_IntfRepoID;
}

CORBA::Object_ptr
Diagnostics_proxyObjectFactory::newProxyObject(Rope *r,CORBA::Octet *key,size_t keysize,IOP::TaggedProfileList *profiles,CORBA::Boolean release)
{
    _proxy_Diagnostics *p = new _proxy_Diagnostics(r,key,keysize,profiles,release);
    if (!p)
    {
        throw CORBA::NO_MEMORY(0,CORBA::COMPLETED_NO);
    }
    return (CORBA::Object_ptr) p;
}

CORBA::Boolean
Diagnostics_proxyObjectFactory::is_a(const char *base_repoId) const
{
    return Diagnostics::_0RL_is_a(base_repoId);

}

Diagnostics_ptr
Diagnostics::_nil()
{
    return Diagnostics_proxyObjectFactory::_nil();
}

static const Diagnostics_proxyObjectFactory Diagnostics_proxyObjectFactory;
Diagnostics_ptr Diagnostics_proxyObjectFactory::__nil_Diagnostics = 0;

