/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*               **** C O M M O N ****                   */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: LIST_INTRTNDEF              */
/*          ============                         */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  This module contains function prototypes fro the platform specific   */
/*  routines within the LISTING routines.                    */
/*                                       */
/*===========================================================================*/

#ifndef PSL__LIST_INTRTNDEF_LOADED
#define PSL__LIST_INTRTNDEF_LOADED 1

/*   Define Incomplete Structures for all referenced types */

void   LIST__FILE_ERROR (struct diagstk *diag_ptr,
                         unsigned long mess_no,
                         char *filename_ptr);

unsigned short  LIST__GET_PAGESIZE (void);

unsigned long   LIST__OPEN_LISTING (struct list_ctx *context_ptr,
                                    const char *def_file_ptr,
                                    const char *rel_file_ptr);

unsigned long   LIST__CLOSE_KEEP (struct list_ctx *context_ptr);

unsigned long   LIST__CLOSE_PRINT (struct list_ctx *context_ptr);

unsigned long   LIST__WRITE (struct list_ctx *context_ptr,
                             unsigned long write_type,
                             const char *string_ptr,
                             unsigned long number);

unsigned long   LIST__CHK_CONTEXT (struct list_ctx *context_ptr);

#endif  /* PSL__LIST_INTRTNDEF_LOADED */
