/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#ifndef PSL__TRM_INTRTNDEF_LOADED
#define PSL__TRM_INTRTNDEF_LOADED 1

/*   Define Incomplete Structures for all specified types */

#include psl_common_file(psl_structures.h) /* Common Structures */    

	 void	TRM__CLEAR_MOVE_MODE (struct tcb *tcb_ptr);	 

unsigned long	TRM__GET_HELP (long hlpidx,
			       const char *hlpkey,
			       char *txtbuf,
			       long *sizbuf,
			       long maxwid,	
			       long maxlin,	
			       long *hlplin);

	 void	TRM__LOG_FKYERR (struct tcb *tcb_ptr,
				 char fkynum);

	 void	TRM__SET_MOVE_MODE (struct tcb *tcb_ptr);

	 void	TRM__SIGNAL_ERR (struct tcb *tcb_ptr,
				 char *rtname_ptr,
				 unsigned long errsts,
				 char *secmsg_ptr);

unsigned long	TRM__SWAPBUF (struct tcb *tcb_ptr);


	 void	TRM__TRC_BELL (struct tcb *tcb_ptr);

	 void	TRM__TRC_CLEAR (struct tcb *tcb_ptr,
				unsigned long clear_flags,
				long line,	
				long column,
				long depth,	
				long width);

	 void	TRM__TRC_CLRUNS (struct tcb *tcb_ptr);

	 void	TRM__TRC_COLOUR (struct tcb *tcb_ptr,
				 char colour,			      
				 unsigned char colour_type);

	 void	TRM__TRC_CURSOR (struct tcb *tcb_ptr,
				 unsigned char cursor_type);

	 void	TRM__TRC_DRWBOX (struct tcb *tcb_ptr,
				 long start_line,		     
				 long start_column,		     
				 long depth,			     
				 long width,			     
				 unsigned long trm_attr,
				 char char_colour,		     
				 char cell_colour);		     

	 void	TRM__TRC_DRWLIN (struct tcb *tcb_ptr,
				 long start_line,		     
				 long start_column,		     
				 long length,			     
				 unsigned char direction,
				 unsigned long trm_attr,
				 char char_colour,		     
				 char cell_colour);		     

	 void	TRM__TRC_EXTHLP (struct tcb *tcb_ptr,
				 const char *hlpkey_ptr,
				 long hlpidx,			     
				 short hlptop,
				 short hlpbot);

	 void	TRM__TRC_FINISH (struct tcb *tcb_ptr);

	 void	TRM__TRC_FKYHLP (struct tcb *tcb_ptr,
				 const char *hlparr_ptr,
				 unsigned long *fkymsk_ptr,
				 long hlpidx,	
				 short hlptop,
				 short hlpbot,
				 unsigned long flags);

	 void	TRM__TRC_FLUSH (struct tcb *tcb_ptr);

	 void	TRM__TRC_INIT (struct tcb *tcb_ptr,
			       unsigned char trmtyp,
			       unsigned long trmflags,
			       struct diagstk *diag_ptr);

	 void	TRM__TRC_INPUT (struct tcb *tcb_ptr,
				char *inpbuf_ptr,
				long bufsiz,			
				long maxchars,			
				short *inplen_ptr,		
				short *inpfky_ptr,
				unsigned long flags,
				long line,			    
				long column,			
				char filler,
				long timeout,			
				char *pmtbuf_ptr,
				unsigned long trm_attr,
				char char_colour,		
				char cell_colour);		

	 void	TRM__TRC_NEWLIN (struct tcb *tcb_ptr,
				 short num_lines);

	 void	TRM__TRC_OUTPUT (struct tcb *tcb_ptr,
				 char *txtbuf_ptr,
				 long text_length,		 
				 long line,			     
				 long column,			 
				 unsigned long trm_attr,
				 char char_colour,		 
				 char cell_colour);		 

	 void	TRM__TRC_OUTLIN (struct tcb *tcb_ptr,
				 const char *msgbuf,	
				 unsigned long flags);

	 void	TRM__TRC_POSCUR (struct tcb *tcb_ptr,
				 short line,
				 short column);

	 void	TRM__TRC_PUTOUT (struct tcb *tcb_ptr);

	 void	TRM__TRC_RESCHR (struct tcb *tcb_ptr,
				 unsigned char char_set);

	 void	TRM__TRC_RESLIN (struct tcb *tcb_ptr,
				 unsigned long reset_flags);

	 void	TRM__TRC_RESTRM (struct tcb *tcb_ptr,
				 unsigned long reset_flags);	    

	 void	TRM__TRC_SCROLL (struct tcb *tcb_ptr,
				 long line,		
				 long column,	
				 long depth,	
				 long width,	
				 unsigned char direction,
				 long distance);		   

	 void	TRM__TRC_SETSCR (struct tcb *tcb_ptr,
				 short start_line,
				 short end_line);

	 void	TRM__TRC_SETSIZ (struct tcb *tcb_ptr,
				 long width,		
				 long depth);		

	 void	TRM__TRC_SETTRM (struct tcb *tcb_ptr);

	 void	TRM__TRC_SETWID (struct tcb *tcb_ptr,
				 unsigned char *width);

	 void	TRM__TRC_SETUNS (struct tcb *tcb_ptr,
				 unsigned long *rtn_addr,
				 long *rtn_param);

	 void	TRM__TRC_WAIT (struct tcb *tcb_ptr,
			       long timeout);


#endif	/* PSL__TRM_INTRTNDEF_LOADED */



