/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#include "CORBARepository.h"
#include "CECFileVar.h"
CECFileVar::CECFileVar(string name,int size,int options,string fid,string file)
        :CECProcessVar(options,name)
{
    _size=size;
    if(_options & VTINT)
        _size=32;
    string filename=Repository->GetVariableFile(file);
    if(filename=="")
        throw CyrException("CECFileVar::CECFileVar","Unable to retrieve file " + file + " for file variable",-1);
    _filename=filename;
    _ifile=new ifstream();
    _ifile->open(_filename.c_str());
    if(!_ifile->good())
    {
        delete _ifile;
        throw CyrException("CECFileVar::CECFileVar","Unable to open file " + file + " for file variable",-1);
    }
    next_value();//read in first value
}

CECFileVar::~CECFileVar()
{
    _ifile->close();
    delete _ifile;
}
void CECFileVar::next_value()
{
    char* buf=new char [_size];
    _ifile->getline(buf,_size);
    _cur_value=buf;
    delete buf;
    if(_ifile->eof())
        reset_seed();//if we've got to the end go to the beginning
}

void CECFileVar::reset_seed(unsigned long seed)
{
    //start from beginning of file
#ifndef HPUX
    if(_ifile->is_open())
#endif
    {
        _ifile->close();
        delete _ifile;
        _ifile=new ifstream();
    }
    _ifile->clear();
    _ifile->open(_filename.c_str());
    if(!_ifile->good())
    {
        if(_ifile->eof())
            throw mdbParseException("Already at end of file" + _filename);
        throw mdbParseException("Unable to open file for file variable " + _filename);
    }
}
