/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
///////////////////////////////////////////////////////////////////////////////
// @doc     CECProcessVar
// @module  CECProcessVar |
//
///////////////////////////////////////////////////////////////////////////////
#include "CECProcessVar.h"
#include <iostream>
CECProcessVar::CECProcessVar(int _options,string name):CECVar(name),_options(_options)
{
    if(_options & VTINT )set_value("0","");
}
CECProcessVar::~CECProcessVar()
{}
// get current value with automatic generation, may need to take account of the '$'
// for variable modifiers

string  CECProcessVar::get_value(const string& expression)
{
    if(!(_options & VONOAUTONEXT))//if automatic value generation
    {
        if((_options & VONEXT) ||(_options & VSFILE))next_value();
        else if ((_options & VORAND) ||(_options & VOREPRAND))generate_value();
    }
    string retstr;
    //if Character variable, truncate to size
    if(_options & VTCHAR )
        retstr=_cur_value.substr(0,_size);
    else
        retstr=_cur_value;
    return retstr;
}
int CECProcessVar::set_value(const string& newval,const string& expression)
{
    _cur_value=newval;
    return 0;
}
