/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#include "CECNodeDefinition.h"
//
//    Definition of localhost
//
const string    LOCALHOST="localhost";

//
CECNodeDefinition::CECNodeDefinition(const string& NodeName)
        :m_Node(NodeName),
        m_InetInfo()
{}


CECNodeDefinition::~CECNodeDefinition()
{}


CECNodeDefinition::CECNodeDefinition(const CECNodeDefinition& NodeDef):m_InetInfo()
{
    this->m_Node=NodeDef.m_Node;
}

string CECNodeDefinition::GetNodeIPAddrAsString()const
{
    //
    //    Get a lowercase version of the supplied node and check if it is 'localhost'
    //
    if (LocalHost())
    {
        return m_InetInfo.GetIPAddressAsString();
    }
    else
    {
        return m_InetInfo.GetIPAddressAsString(m_Node);
    }
}
//could be made neater but probably isn't used often
bool    CECNodeDefinition::LocalHost () const
{
    string lcNode="";
    for (string::const_iterator i = m_Node.begin(); i!=m_Node.end();i++)lcNode += tolower(*i);
    return (lcNode == LOCALHOST);
}
