/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#include "GlobalVariable_i.h"
//try VAR_CATCH_ALL sections to convert any exceptions thrown in Variable use to
//a type that can be sent to the CORBA client with information intact
GlobalVariableImpl::GlobalVariableImpl(CORBAServer* pcorba)
{
    try
    {
        pcorba->ActivateObject(this);   
    }
    VAR_CATCH_ALL
}
GlobalVariableImpl::~GlobalVariableImpl()
{
    try
    {
        delete m_Variable;
    }
    VAR_CATCH_ALL
}
char*  GlobalVariableImpl::get_value(const char*  expression)
{
    try
    {
        CORBA::String_var retstr=m_Variable->get_value(string(expression)).c_str();
        return CORBA::string_dup(retstr);
    }
    VAR_CATCH_ALL
}
CORBA::Long  GlobalVariableImpl::set_value(const char*  newval, const char*  expression)
{
    try
    {
        return m_Variable->set_value(string(newval),string(expression));
    }
    VAR_CATCH_ALL
}
void GlobalVariableImpl::next_value()
{
    try
    {
        m_Variable->next_value();
    }
    VAR_CATCH_ALL
}
void GlobalVariableImpl::generate_value()
{
    try
    {
        m_Variable->generate_value();
    }
    VAR_CATCH_ALL
}
void GlobalVariableImpl::reset_seed()
{
    try
    {
        m_Variable->reset_seed();
    }
    VAR_CATCH_ALL
}
