/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/****************************************************************************
 * @doc     depprmdef.h
 * @module  depprmdef.h | This 'C' format header file contains symbol
 *      definitions for items within a script dependency file. Its
 *              purpose is to isolate in a single location the definition of
 *              dependency items (e.g. parameter codes). These symbols should
 *              be used by all code that generates or processes a script
 *              dependency file.
 *
 ****************************************************************************/

#ifndef depprmdef_h
#define depprmdef_h

/* Dependency type codes */
/* DEF_TYP_SCRIPT = Type script script */
/* DEF_TYP_SCRIMG = Screen image file */
enum deptyp_t   {DEP_TYP_UNKNOWN, DEP_TYP_TEST, DEP_TYP_THREAD, DEP_TYP_CALSCR,
                 DEP_TYP_FILE, DEP_TYP_INCLUDE, DEP_TYP_SCRIMG, DEP_TYP_EXESCR};

/* Dependency item separator character */
#define DEP_SEPCHR '|'
#define DEP_SEPCHRS "|"

/* Dependency TOF type script or TOF */
#define DEP_TOFTYP_SCRIPT   0
#define DEP_TOFTYP_TOF      1

/* Dependency line buffer length */
#define DEPBUFLEN 256

#endif
