#ifndef PSL__STR_PRMDEF_LOADED
#define PSL__STR_PRMDEF_LOADED 1
/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*               **** C O M M O N ****                   */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: STR_PRMDEF                  */
/*          ============                         */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  Parameters for PSL string handling routines.                 */
/*                                       */
/*===========================================================================*/

/*** MODULE STR_PRMDEF ***/

/*  Control character mnemonic types for STR_EXPAND_CTL. */

#define            STR_MNC_ASCII 1
/* ASCII strings */
#define            STR_MNC_CONTROL 2
/* Control commands */
#define            STR_MNC_HEX 3
/* Hexcommands */

/*  Flags for STR_EXPAND_CTL. */

#define            STR_ECF_CMDM 0X1
/* Produce command string */
#define            STR_ECF_FKYM 0X2
/* Convert function keys to mnemonics */
#define            STR_ECF_PASCMDM 0X4
/* Pass command character through */
#define            STR_ECF_WLDCMDM 0X8
/* Commands for wildcard literals */


/*  End of C Include File */

#endif  /* PSL__STR_PRMDEF_LOADED */
