/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

/*===========================================================================*/
/*                                       */
/*             **** C O M M O N ****                 */
/*                                       */
/*===========================================================================*/
/*                                       */
/*          Module Name: TPA_RTNDEF                  */
/*          ============                         */
/*                                       */
/* Description:                                  */
/* ============                                  */
/*                                       */
/*  This module contains function prototypes for the Generic Tparse      */
/*  (TPA) Routines.                              */
/*                                       */
/*===========================================================================*/

#ifndef PSL__TPA_RTNDEF_LOADED
#define PSL__TPA_RTNDEF_LOADED 1

/*   Define Incomplete Structures for all referenced types */

#include <psl_structures.h>     /* Common Structures */

/*
 *  The function prototypes for the TPA routines.
 */
void TPA_CHK_CONDEND (struct tdb *tdb_ptr);

unsigned long TPA_CHK_EOF (struct tpaarg *argblk_ptr);

unsigned long TPA_CHK_EOL (struct tpaarg *argblk_ptr);

void TPA_END (struct tdb *tdb_ptr);

unsigned long TPA_END_SOURCE (struct tdb *tdb_ptr);

unsigned long TPA_ERROR_BLANK (struct tpaarg *argblk_ptr);

unsigned long TPA_ERROR_LINE (struct tpaarg *argblk_ptr);

unsigned long TPA_ERROR_MSG (struct tpaarg *argblk_ptr);

unsigned long TPA_ERROR_STD (struct tpaarg *argblk_ptr);

unsigned long TPA_ERROR_TOKEN (struct tpaarg *argblk_ptr);

unsigned long TPA_GET_CONT_LINE (struct tpaarg *argblk_ptr);

unsigned long TPA_GET_ERR_COUNT (struct tdb *tdb_ptr);


void TPA_GET_EXP_SRCNAM (struct tdb *tdb_ptr,
                         char *buf_ptr,
                         long maxlen);


unsigned long TPA_GET_LINE_COUNT (struct tdb *tdb_ptr);

unsigned long TPA_GET_NEXT_LINE (struct tpaarg *argblk_ptr);

char *TPA_GET_PRSLIN_PTR (struct tdb *tdb_ptr);

char *TPA_GET_SRCLIN_PTR (struct tdb *tdb_ptr);

void *TPA_GET_USRDAT_PTR (struct tdb *tdb_ptr);

void TPA_INC_ERR_COUNT (struct tdb *tdb_ptr);

unsigned long TPA_INIT (struct tdb *tdb_ptr);

unsigned long TPA_INIT_SOURCE (struct tdb *tdb_ptr,
                               char *src_name_ptr);

void TPA_LIST_LINE (struct tdb *tdb_ptr,
                    char *buf_ptr);

void TPA_OUTPUT_SUM (struct tdb *tdb_ptr);

unsigned long TPA_PREMATURE_EOF (struct tpaarg *argblk_ptr);

void TPA_SET_USRDAT_PTR (struct tdb *tdb_ptr,
                         void *usr_ptr);

void TPA_STORE_ERROR (struct tdb *tdb_ptr,
                      unsigned long errnum);

void TPA_UNDERLINE_ERROR (struct tpaarg *argblk_ptr);

#endif  /* PSL__TPA_RTNDEF_LOADED */
