// CORBAInfo.cpp: implementation of the CCORBAInfo class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "testplugin.h"
#include "CORBAInfo.h"
#include <string>
#include <vector>
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CCORBAInfo::CCORBAInfo()
{
	m_pCorba = new CORBAServer ( 0, NULL );
}

CCORBAInfo::~CCORBAInfo()
{
	try
	{
		delete m_pCorba;
	}
	catch(...)
	{
	}
}

BOOL CCORBAInfo::IsTestActive(CString TestName, CString& strReg)
{
	try
	{
		CORBAServer::NameList_t TMList=m_pCorba->GetListOfNames(TestManager::CLASS_NAME);
		for (std::vector<std::string>::size_type iter=0;iter<TMList.size();iter++)  
		{                                                                           
			CORBA::Object_var obj;
			obj=m_pCorba->FindObjectWithName(TestManager::CLASS_NAME, TMList[iter].Id.c_str()); 
		    TestManager_var TM=TestManager::_narrow(obj.inout());
			TestLevel_var TL = TM->GetTestLevel();

			string strTest = TL->TestName();
			if(TestName.CompareNoCase(strTest.c_str()) == 0)
			{
				strReg = TMList[iter].Id.c_str();
				return true;
			}

		}
	}
	catch(...)
	{
	}
	return false;
}

void CCORBAInfo::StopTest(CString strTest)
{
	try
	{
		CORBAServer::NameList_t TMList=m_pCorba->GetListOfNames(TestManager::CLASS_NAME);
		for (std::vector<std::string>::size_type iter=0;iter<TMList.size();iter++)  
		{                                                                           
			CORBA::Object_var obj;
			obj=m_pCorba->FindObjectWithName(TestManager::CLASS_NAME, TMList[iter].Id.c_str()); 
		    TestManager_var TM=TestManager::_narrow(obj.inout());
			TestLevel_var TL = TM->GetTestLevel();
			string TestName = TL->TestName();

			if(strTest.CompareNoCase(TestName.c_str()) == 0)
			{
				TM->Kill();
				return;
			}

		}
	}
	catch(...)
	{
	}
}

void CCORBAInfo::GetActiveTests(CStringArray arrTests)
{
	try
	{
		CORBAServer::NameList_t TMList=m_pCorba->GetListOfNames(TestManager::CLASS_NAME);
		for (std::vector<std::string>::size_type iter=0;iter<TMList.size();iter++)  
		{                                                                           
			CORBA::Object_var obj;
			obj=m_pCorba->FindObjectWithName(TestManager::CLASS_NAME, TMList[iter].Id.c_str()); 
		    TestManager_var TM=TestManager::_narrow(obj.inout());
			TestLevel_var TL = TM->GetTestLevel();

			string strTest = TL->TestName();
			arrTests.Add(strTest.c_str());
		}
	}
	catch(...)
	{
	}
}

void CCORBAInfo::GetSummaryInfo(CString strManagerReg, SUMMARY_INFO& arrSummary)
{
	try
	{
		CORBA::Object_var obj;
        obj=m_pCorba->FindObjectWithName(TestManager::CLASS_NAME, strManagerReg); 
        TestManager_var TM=TestManager::_narrow(obj.inout());
		TestLevel_var TL = TM->GetTestLevel();

		// update information about child levels
		TestLevelList TLList;
		long nTLS = TL->GetChildTestLevelList(TLList);
		long TLiter;
		TestLevel_var CL;
	    for(TLiter=0;TLiter<TLList.length();TLiter++)
	    {
			CL = TLList[TLiter];
			SUMMARY_MAP sMap;
			sMap.strTaskGroup = CL->TestName();
			sMap.nUsers = CL->NoChildThreads(true);
			arrSummary.Add(sMap);
		}
	}
	catch(...)
	{
	}
}

