/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// TaskGroupDefData.h: interface for the CTaskGroupDefData class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TASKGROUPDEFDATA_H__79DFA114_E169_11D4_94C9_00C04F89E392__INCLUDED_)
#define AFX_TASKGROUPDEFDATA_H__79DFA114_E169_11D4_94C9_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CTaskGroupDefData  
{
public:
	CTaskGroupDefData();
	virtual ~CTaskGroupDefData();

	BOOL SaveToBuffer(LPBYTE pData,DWORD &dwBufSize);
	BOOL LoadFromBuffer(LPBYTE pData);

	void SetStartInterval(int n){m_nStartInterval = n;}
	void SetNumVUs(int n){m_nNumVUs = n;}
	void SetNumVUPerInterval(int n){m_nVUPerInterval=n;}
	void SetUsePageTimers(BOOL b){m_bGenPageTimers = b;}
	void SetStatLevel(char ch){m_chStatLevel = ch;}
	void SetStartDelay(int n){m_nStartDelay = n;}
	
	int GetStartInterval(){return m_nStartInterval;}
	int GetNumVUs(){return m_nNumVUs;}
	int GetNumVUPerInterval(){return m_nVUPerInterval;}
	BOOL GetUsePageTimers(){return m_bGenPageTimers;}
	char GetStatLevel(){return m_chStatLevel;}
	int GetStartDelay(){return m_nStartDelay;}

private:	
	int		m_nStartInterval;
	int		m_nNumVUs;
	int		m_nVUPerInterval;
	BOOL	m_bGenPageTimers;
	char	m_chStatLevel;
	int		m_nStartDelay;
};

#endif // !defined(AFX_TASKGROUPDEFDATA_H__79DFA114_E169_11D4_94C9_00C04F89E392__INCLUDED_)
