/* Copyright (C) 2001 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_TESTCTRL_H__81F44676_D4E6_11D4_94C7_00C04F89E392__INCLUDED_)
#define AFX_TESTCTRL_H__81F44676_D4E6_11D4_94C7_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TestCtrl.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CTestCtrl window
#include "CECGridCtrl.h"
#include "TestFile.h"
class CTestPluginDoc;

class CTestCtrl : public CECGridCtrl
{
// Construction
public:
	CTestCtrl();

// Attributes
public:

// Operations
public:

	void SetDocument(CTestPluginDoc* pDoc);

	void Refresh();
	void GenerateScripts();
	
	void DeleteSelection();
	void DeleteItem(int nGroup,int nTask);

	DROPEFFECT OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	BOOL OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTestCtrl)
	protected:
	virtual void PreSubclassWindow();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTestCtrl();

	// Generated message map functions
protected:
	//{{AFX_MSG(CTestCtrl)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnDuplicatetaskgroup();
	//}}AFX_MSG
	afx_msg void OnDblclkTestList(NMHDR* pNMHDR, LRESULT* pResult);
	DECLARE_MESSAGE_MAP()

	CTestFile *m_pTestFile;
	CString m_strTestName;
	CString m_strTestFolder;
	CImageList m_ListImages;
	CMap <CString,LPCTSTR,int,int> m_mapExtToImage;
	CTestPluginDoc *m_pDoc;
	CLIPFORMAT m_ClipFormat;
	CPoint m_ptContextClick;

	const int m_nMaxTasks,m_nMaxGroups;
	const COLORREF m_colMissing,m_colNormal;
	typedef enum{enNameCol,enHostCol,enVUCol,enFirstTaskCol} ListColumns;
	typedef enum{enHostImage,enVUImage,enNameImage} ConfigImages;

	void SetupList();
	void LoadTestFile();

	BOOL HitTest(CPoint pt,int& nRow,int& nCol);

	void GenerateTaskGroupScripts(int nGroup);
	void GenerateTaskGroupTSS(int nGroup);
	void GenerateTaskGroupSCL(int nGroup);
	CString GetScriptHeader(const CString&);
	CString GetScriptOutputPath();
	CString GetTargetType(const CString& strPath);

	BOOL EditScriptTask(int nGroup,int nTask);
	BOOL EditHost(int nGroup);
	BOOL EditVUs(int nGroup);
	BOOL EditProfileTask(int nGroup);

	void InsertScript(int nItem,int nSubItem,const CString& strItemPath);
	void InsertProfile(int nItem,int nSubItem,const CString& strItemPath);

	int RegisterFileExtension(const CString& strFile);
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TESTCTRL_H__81F44676_D4E6_11D4_94C7_00C04F89E392__INCLUDED_)
