// TestRunCombo.cpp : implementation file
//

#include "stdafx.h"
#include "testplugin.h"
#include "TestRunCombo.h"
#include "OstaDefs.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTestRunCombo

CTestRunCombo::CTestRunCombo()
{
}

CTestRunCombo::~CTestRunCombo()
{
}


BEGIN_MESSAGE_MAP(CTestRunCombo, CComboBox)
	//{{AFX_MSG_MAP(CTestRunCombo)
	ON_WM_KILLFOCUS()
	ON_CONTROL_REFLECT(CBN_CLOSEUP, OnCloseup)
	ON_WM_TIMER()
	ON_CONTROL_REFLECT(CBN_DROPDOWN, OnDropdown)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTestRunCombo message handlers
void CTestRunCombo::OnKillFocus(CWnd* pNewWnd) 
{
	CComboBox::OnKillFocus(pNewWnd);
	
	m_ctlToolTip.ShowWindow(SW_HIDE);
}

void CTestRunCombo::OnCloseup() 
{
	KillTimer(1);
	m_ctlToolTip.ShowWindow(SW_HIDE);
}

void CTestRunCombo::OnDropdown() 
{
	SetTimer(1, 400, NULL);
}

void CTestRunCombo::OnTimer(UINT nIDEvent) 
{
	CFileStatus fs;
	CString str;
	if(GetCurrentRun(str) && CFile::GetStatus(str + strSummaryFile,fs))
    {
		//Get tip text
		CString strText;
		CStdioFile f(str + strSummaryFile,CFile::modeRead);
		f.ReadString(strText);
		f.Close();

		
		int nCurSel = GetCurSel();
	    CRect rc;
        GetDroppedControlRect(rc);
        int nHeight = GetItemHeight(0) * ((nCurSel - GetTopIndex()) + 1);

        //Show tip
		m_ctlToolTip.SetWindowText(strText);
		m_ctlToolTip.SetWindowPos(&CWnd::wndTopMost,rc.right + 5,rc.top + nHeight,0,0,
									SWP_NOSIZE|SWP_NOACTIVATE|SWP_SHOWWINDOW);
	}
	else
		m_ctlToolTip.ShowWindow(SW_HIDE);

	CComboBox::OnTimer(nIDEvent);
}

void CTestRunCombo::PreSubclassWindow() 
{
	m_ctlToolTip.CreateEx(0,_T("STATIC"),NULL,WS_POPUP|WS_BORDER,CRect(0,0,100,100),AfxGetMainWnd(),0);
	m_ctlToolTip.SetFont(GetFont());

	CComboBox::PreSubclassWindow();
}

void CTestRunCombo::SetTestFolder(const CString& strFolder)
{
	m_strTestFolder = strFolder;	
	if(m_strTestFolder.Right(1) != "\\")
		m_strTestFolder += "\\";
}

void CTestRunCombo::Refresh()
{
	ResetContent();

	if(m_strTestFolder.IsEmpty())
		return;

	CFileFind FF;
	if(!FF.FindFile(m_strTestFolder + "*.00?"))
		return;

	BOOL bContinue=true;
	while(bContinue)
	{
		bContinue = FF.FindNextFile();

		if(FF.IsDirectory() && !FF.IsDots() && !FF.IsHidden())
			AddString(FF.GetFileName());
	}
}

BOOL CTestRunCombo::GetCurrentRun(CString& strRunPath)
{
	int nCurSel = GetCurSel();
	if(nCurSel == CB_ERR)
		return false;

	CString strRun;
	GetLBText(nCurSel,strRun);
	strRunPath = m_strTestFolder + strRun + "\\";

	return true;
}

/////////////////////////////////////////////////////////////////////////////
// CTipWnd

CTipWnd::CTipWnd()
{
	m_bkBrush.CreateSolidBrush(GetSysColor(COLOR_INFOBK));
}

CTipWnd::~CTipWnd()
{
}


BEGIN_MESSAGE_MAP(CTipWnd, CStatic)
	//{{AFX_MSG_MAP(CTipWnd)
	ON_WM_CTLCOLOR_REFLECT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTipWnd message handlers

HBRUSH CTipWnd::CtlColor(CDC* pDC, UINT nCtlColor) 
{
	pDC->SetTextColor(GetSysColor(COLOR_INFOTEXT));

	// Set the background mode for text to transparent 
	// so background will show thru.
	pDC->SetBkMode(TRANSPARENT);

	return (HBRUSH)m_bkBrush;
}

void CTipWnd::SetWindowText(LPCTSTR lpszString)
{
	CClientDC dc(this);
	CSize szText = dc.GetTextExtent(lpszString);
	
	SetWindowPos(NULL,0,0,szText.cx,szText.cy,SWP_NOZORDER|SWP_NOMOVE|SWP_NOACTIVATE);

	CStatic::SetWindowText(lpszString);
}