/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// BrowserInformation.h: interface for the CBrowserInformation class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_BROWSERINFORMATION_H__ACB94017_FFCC_11D3_AC85_00105A483E3C__INCLUDED_)
#define AFX_BROWSERINFORMATION_H__ACB94017_FFCC_11D3_AC85_00105A483E3C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "EnumData.h"

class CBrowserInformation
{
protected :
    CWnd*             m_pWnd;


public:
    CBrowserInformation(CWnd* _pWnd=NULL);
    virtual ~CBrowserInformation();

    //Get Browser default parameters
    virtual BOOL GetDefaultParameters( _TPreferencesProxyData *pData ) ;

    //Save default registry parameters in a temporary file
    virtual void SaveDefaultRegistryInfo()
    {}
    ;

    //Modify the registry for the capture
    virtual void ModifyRegistryForCapture( long lPort )
    {}
    ;

    //Reinit the registry parameters with the parameters saved in the temp file
    virtual void SetDefaultParametersInRegistry()
    {}
    ;

    //Get Browser Path
    virtual BOOL GetBrowserFullPath( CString &strPath )
    {
        return TRUE;
    };

    //Verify if the user has checked "use a server proxy" and the parameters for http proxy
    // and https proxy are OK.
    virtual BOOL IsInternetSettingOK()
    {
        return TRUE;
    } ;

    //Verify if the browser path exists in the registry
    BOOL IsKeyValueExist( HKEY _hKey , LPCTSTR _lpSubKey , LPCTSTR _szEntry ) ;

    //Verify if a special browser mode exists in the registry
    BOOL IsKeyExist( HKEY _hKey , LPCTSTR _lpSubKey ) ;

    void ModifyProxyForCapture( CString &strProxy , long lPort ) ;
    void ModifySpecificProxyForCapture( CString &strProxy , TCHAR *pczType , long lPort) ;

};

#endif // !defined(AFX_BROWSERINFORMATION_H__ACB94017_FFCC_11D3_AC85_00105A483E3C__INCLUDED_)
