/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// Tokenizer.h: interface for the CTokenizer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TOKENIZER_H__D05E9AF4_1F54_11D3_92AA_00104B4B2995__INCLUDED_)
#define AFX_TOKENIZER_H__D05E9AF4_1F54_11D3_92AA_00104B4B2995__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CTokenizer
{
    //Attribute
private:
    CString m_strValue;
    CString m_strTempValue;
    CString m_strSeparator;
    CString m_strSeparatorEnd;

    //Construction
public:
    CTokenizer(CString _strValue, CString _strSeparatorBegin,
               CString _strSeparatorEnd);
    CTokenizer(CString _strValue, CString _strSeparator);
    CTokenizer(CString _strSeparator);
    virtual ~CTokenizer();

    //Operation
public:
    //Generation de la TokenSet
    void    Clear();
    void    Add(CString _strToken);
    void    Add(long _lToken);
    CString GetResult();

    //Extraction de la TokenSet
    void    Reset();
    long    GetLong();
    CString GetString();
    BOOL    Exist();

};

#endif // !defined(AFX_TOKENIZER_H__D05E9AF4_1F54_11D3_92AA_00104B4B2995__INCLUDED_)
