

#include "stdafx.h"
#include <afxdllx.h>
#include "PluginTypes.h"
#include "resource.h"       // main symbols
#include "ScriptMonDlg.h"
#include "ScriptSummary.h"
#include "TestFile.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


static AFX_EXTENSION_MODULE CHttpMonDLL = { NULL, NULL };

CMultiDocTemplate*      pTInfoDocTemplate    = NULL;
CMultiDocTemplate*      pVUsersDocTemplate    = NULL;
CStringArray m_arrTasks;
CString m_strTaskGroup = "";

HINSTANCE m_hInstance = NULL;
extern "C" int APIENTRY
    DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	m_hInstance = hInstance;
    // Remove this if you use lpReserved
    UNREFERENCED_PARAMETER(lpReserved);

    if (dwReason == DLL_PROCESS_ATTACH)
    {
        TRACE0("CHttpMonDLL.DLL Initializing!\n");

        // Extension DLL one-time initialization
        if (!AfxInitExtensionModule(CHttpMonDLL, hInstance))
            return 0;

        // Insert this DLL into the resource chain
        // NOTE: If this Extension DLL is being implicitly linked to by
        //  an MFC Regular DLL (such as an ActiveX Control)
        //  instead of an MFC application, then you will want to
        //  remove this line from DllMain and put it in a separate
        //  function exported from this Extension DLL.  The Regular DLL
        //  that uses this Extension DLL should then explicitly call that
        //  function to initialize this Extension DLL.  Otherwise,
        //  the CDynLinkLibrary object will not be attached to the
        //  Regular DLL's resource chain, and serious problems will
        //  result.

    }
    else if (dwReason == DLL_PROCESS_DETACH)
    {
        TRACE0("CHttpMonDLL.DLL Terminating!\n");

        // Terminate the library before destructors are called
        AfxTermExtensionModule(CHttpMonDLL);

    }

    return 1;   // ok
}

extern "C" AFX_EXT_API
BOOL OpenSTAVerify()
{
	return true;
}

extern "C" AFX_EXT_API
void GetTitle(CString& strTitle)
{
	strTitle = "HTTP Monitor Plugin";
}

extern "C" AFX_EXT_API
int GetType()
{
	return TEST_MONITOR_PLUGIN;
}

extern "C" AFX_EXT_API
void GetPackage(CString& strPackage)
{
	strPackage = "HTTP";
}

extern "C" AFX_EXT_API
BOOL IsSupportedExtension(CString strExt)
{
	if (strExt == "HTP")
		return true;
    return false;
}

extern "C" AFX_EXT_API
void GetAvailableScreens(CTestFile* pTestFile, int nTaskGroup, CStringArray& arrScreens)
{
	m_arrTasks.RemoveAll();

	if (pTestFile->GetNumTasks(nTaskGroup) > 0)
	{
		arrScreens.Add("Summary");
	}
	for (int i =0; i<pTestFile->GetNumTasks(nTaskGroup); i++)
	{
		arrScreens.Add(pTestFile->GetTaskName(nTaskGroup, i));
		m_arrTasks.Add(pTestFile->GetTaskName(nTaskGroup, i));
	}

	m_strTaskGroup = pTestFile->GetTaskGroupName(nTaskGroup);
}

extern "C" AFX_EXT_API
CWnd* ViewScreen(CString strManagerReg, CString strTestRunPath, CStringArray& arrScreens, CWnd* pParent)
{
	// Set the resource handle to be this dll while opening a document
	if (arrScreens.GetSize() != 1)
		return NULL;

	// Get the current Resource handle
	HINSTANCE hInst = AfxGetResourceHandle();

	CString strTaskName = arrScreens.GetAt(0);
	if (strTaskName == "Summary")
	{
		AfxSetResourceHandle(m_hInstance);
		CScriptSummary* pSummary = new CScriptSummary();
		pSummary->InitMonitor(m_strTaskGroup, m_arrTasks ,strManagerReg);
		pSummary->Create(IDD_SUMMARY, pParent);
		pSummary->ShowWindow(SW_SHOW);
		AfxSetResourceHandle(hInst);
		return pSummary;
	}
	else
	{
		AfxSetResourceHandle(m_hInstance);
		CScriptMonDlg* pMon = new CScriptMonDlg();
		pMon->InitMonitor(strTestRunPath, strTaskName, strManagerReg);
		pMon->Create(IDD_SCRIPTMON, pParent);
		pMon->ShowWindow(SW_SHOW);
		// Restore the resource handle
		AfxSetResourceHandle(hInst);
		return pMon;
	}

    return NULL;	
}
