/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_FILTERDLG_H__A24B2FE1_3E00_11D4_BDA9_00C04F89E392__INCLUDED_)
#define AFX_FILTERDLG_H__A24B2FE1_3E00_11D4_BDA9_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FilterDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFilterDlg dialog
#include "DataTypes.h"

class CFilterDlg : public CDialog
{
    // Construction
public:
    CFilterDlg(FilterData *pFilterData,CWnd* pParent = NULL);   // standard constructor

    // Dialog Data
    //{{AFX_DATA(CFilterDlg)
    enum { IDD = IDD_FILTER_DLG };
    CListCtrl   m_ctlUserIdList;
    CListCtrl   m_ctlUrlList;
    CEdit   m_ctlEndTime;
    CEdit   m_ctlStartTime;
    CSpinButtonCtrl m_ctlRespTimeStartSpin;
    CSpinButtonCtrl m_ctlRespTimeEndSpin;
    CSpinButtonCtrl m_ctlRespCodeStartSpin;
    CSpinButtonCtrl m_ctlRespCodeEndSpin;
    CSpinButtonCtrl m_ctlReplySizeStartSpin;
    CSpinButtonCtrl m_ctlReplySizeEndSpin;
    DWORD   m_dwReplySizeEnd;
    DWORD   m_dwReplySizeStart;
    DWORD   m_dwRespTimeEnd;
    DWORD   m_dwRespTimeStart;
    DWORD   m_dwRespCodeEnd;
    DWORD   m_dwRespCodeStart;
    CString m_strEndTime;
    CString m_strStartTime;
    //}}AFX_DATA


    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CFilterDlg)
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    //}}AFX_VIRTUAL

    // Implementation
protected:

    // Generated message map functions
    //{{AFX_MSG(CFilterDlg)
    virtual BOOL OnInitDialog();
    afx_msg void OnDefaults();
    virtual void OnOK();
    afx_msg void OnGetdispinfoUserIdList(NMHDR* pNMHDR, LRESULT* pResult);
    afx_msg void OnGetdispinfoUrlList(NMHDR* pNMHDR, LRESULT* pResult);
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()

    FilterData *m_pFilterData;

    CStringArray m_arstrUrls;
    CStringArray m_arstrUserIds;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILTERDLG_H__A24B2FE1_3E00_11D4_BDA9_00C04F89E392__INCLUDED_)
