/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

#if !defined(AFX_HTTPSTATSOCXCTL_H__067240FE_4131_11D4_BDAD_00C04F89E392__INCLUDED_)
#define AFX_HTTPSTATSOCXCTL_H__067240FE_4131_11D4_BDAD_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

// HttpStatsOcxCtl.h : Declaration of the CHttpStatsOcxCtrl ActiveX Control class.

/////////////////////////////////////////////////////////////////////////////
// CHttpStatsOcxCtrl : See HttpStatsOcxCtl.cpp for implementation.
#include "HttpStatsDlg.h"

class CHttpStatsOcxCtrl : public COleControl
{
    DECLARE_DYNCREATE(CHttpStatsOcxCtrl)

    // Constructor
public:
    CHttpStatsOcxCtrl();

    // Overrides
    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CHttpStatsOcxCtrl)
public:
    virtual void OnDraw(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid);
    //  virtual void DoPropExchange(CPropExchange* pPX);
    virtual void OnResetState();
    //}}AFX_VIRTUAL

    // Implementation
protected:
    ~CHttpStatsOcxCtrl();

    DECLARE_OLECREATE_EX(CHttpStatsOcxCtrl)    // Class factory and guid
    DECLARE_OLETYPELIB(CHttpStatsOcxCtrl)      // GetTypeInfo
    //  DECLARE_PROPPAGEIDS(CHttpStatsOcxCtrl)     // Property page IDs
    DECLARE_OLECTLTYPE(CHttpStatsOcxCtrl)       // Type name and misc status

    // Message maps
    //{{AFX_MSG(CHttpStatsOcxCtrl)
    afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
    afx_msg void OnSize(UINT nType, int cx, int cy);
    //}}AFX_MSG
    afx_msg BOOL OnEraseBkgnd(CDC *pDC);
    DECLARE_MESSAGE_MAP()

    // Dispatch maps
    //{{AFX_DISPATCH(CHttpStatsOcxCtrl)
    afx_msg BOOL LoadStatsFile(LPCTSTR strPath);
    afx_msg void ShowFilter();
    //}}AFX_DISPATCH
    DECLARE_DISPATCH_MAP()

    // Event maps
    //{{AFX_EVENT(CHttpStatsOcxCtrl)
    //}}AFX_EVENT
    DECLARE_EVENT_MAP()

    // Dispatch and event IDs
public:
    enum {
        //{{AFX_DISP_ID(CHttpStatsOcxCtrl)
        dispidLoadStatsFile = 1L,
        dispidShowFilter = 2L,
        //}}AFX_DISP_ID
    };

protected:
    CHttpStatsDlg m_dlgHttpStats;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HTTPSTATSOCXCTL_H__067240FE_4131_11D4_BDAD_00C04F89E392__INCLUDED)
