// NTPerfGraphs.h: interface for the CNTPerfGraphs class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NTPERFGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_)
#define AFX_NTPERFGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CGraphWnd;

typedef struct
{
	DWORD dwIP;
	int nIndex;
	DWORD dwStartTime;
	DWORD dwEndTime;
	double dValue;
}NTPStat;

typedef CList <NTPStat,NTPStat&> NTPStatList;

struct NTPHeader
{
	bool bInFilter;
	DWORD dwIP;
	int nIndex;
	CString strQuery;

	NTPHeader()
	{
		bInFilter = true;
	}

	NTPStatList listStats;
};

typedef CList <NTPHeader*,NTPHeader*> NTPHeaderList;

class CNTPerfGraphs  
{
public:
	CNTPerfGraphs();
	virtual ~CNTPerfGraphs();

	void LoadRun(const CString& strRunFolder);
	CWnd *DisplayGraph(const CString& strName,CWnd *pParent,const CRect& rcBounds);
	void GetAvailableGraphs(CStringArray& arstrGraphs);

private:
	BOOL LoadGraph	(const CString& strName,CGraphWnd *pGraph);
	void LoadStats();

private:
	CString m_strLoadedRun;
	DWORD m_dwTestStartTime;

	NTPHeaderList m_listNTPData;

	const CString m_strCustomNTP;
};

#endif // !defined(AFX_HTTPGRAPHS_H__30804214_E70F_11D4_94C9_00C04F89E392__INCLUDED_)
