/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
#if !defined(AFX_XCHARTCTRL_H__DCC00DE4_A660_4767_8ECC_755654E9B199__INCLUDED_)
#define AFX_XCHARTCTRL_H__DCC00DE4_A660_4767_8ECC_755654E9B199__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// Machine generated IDispatch wrapper class(es) created by Microsoft Visual C++

// NOTE: Do not modify the contents of this file.  If this class is regenerated by
//  Microsoft Visual C++, your modifications will be overwritten.

/////////////////////////////////////////////////////////////////////////////
// CXChartCtrl wrapper class

class CXChartCtrl : public CWnd
{
protected:
	DECLARE_DYNCREATE(CXChartCtrl)
public:
	CLSID const& GetClsid()
	{
		static CLSID const clsid
			= { 0xb3b2d77b, 0x6215, 0x11d4, { 0x94, 0x89, 0x0, 0xc0, 0x4f, 0x89, 0xe3, 0x92 } };
		return clsid;
	}
	virtual BOOL Create(LPCTSTR lpszClassName,
		LPCTSTR lpszWindowName, DWORD dwStyle,
		const RECT& rect,
		CWnd* pParentWnd, UINT nID,
		CCreateContext* pContext = NULL)
	{ return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID); }

    BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle,
		const RECT& rect, CWnd* pParentWnd, UINT nID,
		CFile* pPersist = NULL, BOOL bStorage = FALSE,
		BSTR bstrLicKey = NULL)
	{ return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID,
		pPersist, bStorage, bstrLicKey); }

// Attributes
public:
	CString GetTitleText();
	void SetTitleText(LPCTSTR);
	unsigned long GetTitleBkColor();
	void SetTitleBkColor(unsigned long);
	unsigned long GetPlotBkColor();
	void SetPlotBkColor(unsigned long);
	CString GetYAxisLabel();
	void SetYAxisLabel(LPCTSTR);
	CString GetXAxisLabel();
	void SetXAxisLabel(LPCTSTR);
	CString GetY2AxisLabel();
	void SetY2AxisLabel(LPCTSTR);
	long GetYAxisMinimum();
	void SetYAxisMinimum(long);
	long GetXAxisMinimum();
	void SetXAxisMinimum(long);
	long GetY2AxisMinimum();
	void SetY2AxisMinimum(long);
	long GetYAxisMaximum();
	void SetYAxisMaximum(long);
	long GetXAxisMaximum();
	void SetXAxisMaximum(long);
	long GetY2AxisMaximum();
	void SetY2AxisMaximum(long);
	unsigned long GetTitleTextColor();
	void SetTitleTextColor(unsigned long);
	CString GetTitleFont();
	void SetTitleFont(LPCTSTR);
	VARIANT GetDataColors();
	void SetDataColors(const VARIANT&);
	CString GetLabelFont();
	void SetLabelFont(LPCTSTR);
	unsigned long GetGridColor();
	void SetGridColor(unsigned long);
	unsigned long GetLabelColor();
	void SetLabelColor(unsigned long);
	unsigned long GetAxisTextColor();
	void SetAxisTextColor(unsigned long);
	VARIANT GetData();
	void SetData(const VARIANT&);

// Operations
public:
	long GetSeriesStyle(long lSeries);
	void SetSeriesStyle(long lSeries, long nNewValue);
	void ShowLegend(BOOL bShow);
	CString GetLegendText(short nSeries);
	void SetLegendText(short nSeries, LPCTSTR lpszNewValue);
	void EditCopy();
	double GetDataPoint(long nIndex, long nSeries);
	void SetDataPoint(long nIndex, long nSeries, double newValue);
	void AddDataPoint(long nSeries, double dValue);
	BOOL GetSeriesOnSecondaryAxis(short nSeries);
	void SetSeriesOnSecondaryAxis(short nSeries, BOOL bNewValue);
	CString GetSeriesAnnotation(short nSeries);
	void SetSeriesAnnotation(short nSeries, LPCTSTR lpszNewValue);
	void RemoveSeries(LPCTSTR szSeries);
	void EnableZoom(BOOL bEnable);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_XCHARTCTRL_H__DCC00DE4_A660_4767_8ECC_755654E9B199__INCLUDED_)
