/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/
// SNMPPluginView.h : interface of the CSNMPPluginView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SNMPPLUGINVIEW_H__47C605A7_4BA0_47C3_B53B_791CCFBA36CD__INCLUDED_)
#define AFX_SNMPPLUGINVIEW_H__47C605A7_4BA0_47C3_B53B_791CCFBA36CD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "CECGridCtrl.h"


class CSNMPPluginView : public CFormView
{
protected: // create from serialization only
	CSNMPPluginView();
	DECLARE_DYNCREATE(CSNMPPluginView)

public:
	//{{AFX_DATA(CSNMPPluginView)
	enum { IDD = IDD_SNMPPLUGIN_FORM };
	CButton	m_ctlGroup;
	//}}AFX_DATA

// Attributes
public:
	CSNMPPluginDoc* GetDocument();
	BOOL WriteProfile(CString strFilePath) ;
	BOOL ReadProfile(CString strFilePath) ;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSNMPPluginView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL
    afx_msg LRESULT OnButtonPressed(WPARAM,LPARAM);

// Implementation
public:
	virtual ~CSNMPPluginView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CSNMPPluginView)
	afx_msg void OnCancelEditSrvr();
	afx_msg void OnAddRow();
	afx_msg void OnRemoveRow();
	afx_msg void OnScan();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

    CECGridCtrl m_wndGrid;
	void EditQuery(int nRow);
	enum { enDesc = 0, enServer, enQuery, enInterval, enDelta};
	CStringArray m_arrServers;
private:
	BOOL m_bLoaded;

	CToolTipCtrl* m_pToolTip;
};

#ifndef _DEBUG  // debug version in SNMPPluginView.cpp
inline CSNMPPluginDoc* CSNMPPluginView::GetDocument()
   { return (CSNMPPluginDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SNMPPLUGINVIEW_H__47C605A7_4BA0_47C3_B53B_791CCFBA36CD__INCLUDED_)
