/* Copyright (C) 2000 Cyrano SA
 
   This file is part of OpenSTA
 
   OpenSTA is free software; you can redistribute it and/or modify it under
   the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2, or (at your option) any later
   version.
 
   OpenSTA is distributed in the hope that it will be useful, but WITHOUT ANY
   WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.
 
   You should have received a copy of the GNU General Public License along
   with OpenSTA; see the file COPYING.  If not, write to the Free Software
   Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
 
   For more information about the GNU Public license see:
   http://www.gnu.org/copyleft/gpl.html
 
   OpenSTA is at:
   http://www.opensta.org/
   http://opensta.sourceforge.net/
*/

// ExcelExport.h: interface for the ExcelExport class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EXCELEXPORT_H__A690CB94_EDBC_11D3_BD80_00C04F89E392__INCLUDED_)
#define AFX_EXCELEXPORT_H__A690CB94_EDBC_11D3_BD80_00C04F89E392__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Excel8.h"
class CXChartCtrl;

class CExcelExport
{
public:
    CExcelExport();
    virtual ~CExcelExport();

    BOOL SetGraph(CXChartCtrl* pGraph);
    static BOOL IsExcelRegistered();
private:
    const COleVariant covOptional;

    _Application m_app;
    _Worksheet m_sheet;
    CXChartCtrl *m_pGraph;

private:
    BOOL InitialiseExcel();
    BOOL SetupSheetData();
    BOOL FillEmptyCells(int nGroup);
};

#endif // !defined(AFX_EXCELEXPORT_H__A690CB94_EDBC_11D3_BD80_00C04F89E392__INCLUDED_)
